searchNodes=[{"doc":"Documentation for EnhancedAccess .","ref":"EnhancedAccess.html","title":"EnhancedAccess","type":"module"},{"doc":"Be able to access any key in a Map or a Keyword list through the Access protocol Examples iex&gt; get_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } } , [ EnhancedAccess . all_keys ( ) , :b ] ) [ 1 , 2 ] iex&gt; get_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } } , [ EnhancedAccess . all_keys ( ) ] ) [ %{ b : 1 } , %{ b : 2 } ] iex&gt; get_in ( [ a : %{ b : 1 } , c : %{ b : 2 } ] , [ EnhancedAccess . all_keys ( ) ] ) [ %{ b : 1 } , %{ b : 2 } ] iex&gt; deeper_nesting = %{ a : %{ b : %{ c : 1 } } , d : %{ b : %{ c : 2 } } , e : %{ b : 1 } } iex&gt; get_in ( deeper_nesting , [ EnhancedAccess . all_keys ( ) , :b , EnhancedAccess . optional_key ( :c ) ] ) [ 1 , 2 , nil ] iex&gt; update_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } } , [ EnhancedAccess . all_keys ( ) , :b ] , &amp; ( &amp;1 + 1 ) ) %{ a : %{ b : 2 } , c : %{ b : 3 } } iex&gt; update_in ( [ a : %{ b : 1 } , c : %{ b : 2 } ] , [ EnhancedAccess . all_keys ( ) , :b ] , &amp; ( &amp;1 + 1 ) ) [ a : %{ b : 2 } , c : %{ b : 3 } ] iex&gt; update_in ( [ a : [ b : 1 ] , c : [ b : 2 ] ] , [ EnhancedAccess . all_keys ( ) , :b ] , &amp; ( &amp;1 + 1 ) ) [ a : [ b : 2 ] , c : [ b : 3 ] ] iex&gt; get_and_update_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } } , [ EnhancedAccess . all_keys ( ) , :b ] , &amp; { &amp;1 , &amp;1 + 1 } ) { [ 1 , 2 ] , %{ a : %{ b : 2 } , c : %{ b : 3 } } } iex&gt; pop_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } } , [ EnhancedAccess . all_keys ( ) , :b ] ) { [ 1 , 2 ] , %{ a : %{ } , c : %{ } } }","ref":"EnhancedAccess.html#all_keys/0","title":"EnhancedAccess.all_keys/0","type":"function"},{"doc":"Allow for optional keys in the Access protocol Examples iex&gt; get_in ( %{ a : %{ b : 1 } , c : 1 } , [ EnhancedAccess . all_keys ( ) , EnhancedAccess . optional_key ( :b ) ] ) [ 1 , nil ] iex&gt; get_in ( %{ a : 1 , c : %{ b : 1 } } , [ EnhancedAccess . all_keys ( ) , EnhancedAccess . optional_key ( :b ) ] ) [ nil , 1 ] iex&gt; deeper_nesting = %{ a : %{ b : %{ c : 1 } } , d : %{ b : %{ c : 2 } } , e : %{ d : 1 } } iex&gt; get_in ( deeper_nesting , [ EnhancedAccess . all_keys ( ) , EnhancedAccess . optional_key ( :b ) , :c ] ) [ 1 , 2 , nil ] iex&gt; update_in ( %{ a : %{ b : 1 } , c : %{ d : 2 } } , [ EnhancedAccess . all_keys ( ) , EnhancedAccess . optional_key ( :b ) ] , &amp; ( &amp;1 + 1 ) ) %{ a : %{ b : 2 } , c : %{ d : 2 } } iex&gt; update_in ( [ a : [ b : 1 ] , c : [ d : 2 ] ] , [ EnhancedAccess . all_keys ( ) , EnhancedAccess . optional_key ( :b ) ] , &amp; ( &amp;1 + 1 ) ) [ a : [ b : 2 ] , c : [ d : 2 ] ] iex&gt; get_and_update_in ( %{ a : %{ b : 1 } , c : %{ d : 2 } } , [ EnhancedAccess . all_keys ( ) , EnhancedAccess . optional_key ( :b ) ] , &amp; { &amp;1 , &amp;1 + 1 } ) { [ 1 , nil ] , %{ a : %{ b : 2 } , c : %{ d : 2 } } } iex&gt; pop_in ( %{ a : %{ b : 1 } , c : %{ d : 2 } } , [ EnhancedAccess . all_keys ( ) , EnhancedAccess . optional_key ( :b ) ] ) { [ 1 , nil ] , %{ a : %{ } , c : %{ d : 2 } } }","ref":"EnhancedAccess.html#optional_key/1","title":"EnhancedAccess.optional_key/1","type":"function"},{"doc":"Be able to access any key except some key you want to skip in a Map or a Keyword list through the Access protocol Examples iex&gt; get_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } , d : %{ b : 3 } } , [ EnhancedAccess . skip_keys ( [ :d ] ) , :b ] ) [ 1 , 2 ] iex&gt; get_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } , d : %{ b : 3 } } , [ EnhancedAccess . skip_keys ( [ :d ] ) ] ) [ %{ b : 1 } , %{ b : 2 } ] iex&gt; get_in ( [ a : %{ b : 1 } , c : %{ b : 2 } , d : %{ b : 3 } ] , [ EnhancedAccess . skip_keys ( [ :d ] ) ] ) [ %{ b : 1 } , %{ b : 2 } ] iex&gt; deeper_nesting = %{ a : %{ b : %{ c : 1 } } , d : %{ b : %{ c : 2 } } } iex&gt; get_in ( deeper_nesting , [ EnhancedAccess . skip_keys ( [ :d ] ) , :b , :c ] ) [ 1 ] iex&gt; update_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } , d : %{ b : 3 } } , [ EnhancedAccess . skip_keys ( [ :d ] ) , :b ] , &amp; ( &amp;1 + 1 ) ) %{ a : %{ b : 2 } , c : %{ b : 3 } , d : %{ b : 3 } } iex&gt; update_in ( [ a : %{ b : 1 } , c : %{ b : 2 } , d : %{ b : 3 } ] , [ EnhancedAccess . skip_keys ( [ :d ] ) , :b ] , &amp; ( &amp;1 + 1 ) ) [ a : %{ b : 2 } , c : %{ b : 3 } , d : %{ b : 3 } ] iex&gt; update_in ( [ a : [ b : 1 ] , c : [ b : 2 ] , d : [ b : 3 ] ] , [ EnhancedAccess . skip_keys ( [ :d ] ) , :b ] , &amp; ( &amp;1 + 1 ) ) [ a : [ b : 2 ] , c : [ b : 3 ] , d : [ b : 3 ] ] iex&gt; get_and_update_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } , d : %{ b : 3 } } , [ EnhancedAccess . skip_keys ( [ :d ] ) , :b ] , &amp; { &amp;1 , &amp;1 + 1 } ) { [ 1 , 2 ] , %{ a : %{ b : 2 } , c : %{ b : 3 } , d : %{ b : 3 } } } iex&gt; pop_in ( %{ a : %{ b : 1 } , c : %{ b : 2 } , d : %{ b : 3 } } , [ EnhancedAccess . skip_keys ( [ :d ] ) , :b ] ) { [ 1 , 2 ] , %{ a : %{ } , c : %{ } , d : %{ b : 3 } } }","ref":"EnhancedAccess.html#skip_keys/1","title":"EnhancedAccess.skip_keys/1","type":"function"}]